// Moved back to ThinkFrame to ensure
// XMomentum compatibility.

addHook("ThinkFrame", function()
	for player in players.iterate
		if (player.mo and player.mo.valid) and player.mo.skin != "windows" then return
		elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
			if player.isxmomentum == nil or player.normalspeed < skins[player.mo.skin].normalspeed then
				player.normalspeed = skins[player.mo.skin].normalspeed
			end
			if not P_IsObjectOnGround(player.mo) and player.cpucooler then
				if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 3) / 2 then
					player.normalspeed = (skins[player.mo.skin].normalspeed * 3) / 2
				end
			elseif (player.powers[pw_invulnerability] != 0 and player.powers[pw_sneakers] == 0) then
				if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 4) / 3 then
					player.normalspeed = (skins[player.mo.skin].normalspeed * 4) / 3
				end
			elseif player.powers[pw_sneakers] != 0 then
				if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 5) / 4 then
					player.normalspeed = (skins[player.mo.skin].normalspeed * 5) / 4
				end
			end
			if player.powers[pw_super] != 0 then
				if player.hyper == nil or player.hyper.capable == false then
					if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 3) / 2 then
						player.normalspeed = (skins[player.mo.skin].normalspeed * 3) / 2
					end
				elseif player.hyper.capable == true then
					if player.normalspeed < (skins[player.mo.skin].normalspeed * 7) / 4 then
						player.normalspeed = (skins[player.mo.skin].normalspeed * 7) / 4
					end
				end
			end
			if player.cpanel > 0 and player.playerstate == PST_LIVE then
				if player.exiting != 0 then
					player.cpanel = 0
				end
				P_SpawnGhostMobj(player.mo)
				if P_PlayerInPain(player) == true then player.cpanel = 0 end
				if player.exiting != 0 then player.cpanel = 0 end
				player.thrustfactor = (skins[player.mo.skin].thrustfactor * 7) / 4
				if player.powers[pw_super] == 0 then
					if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 9) / 4 then
						player.normalspeed = (skins[player.mo.skin].normalspeed * 9) / 4
					end
				elseif player.powers[pw_super] != 0 then
					if player.hyper == nil or player.hyper.capable == false then
						if player.isxmomentum == nil or player.normalspeed < (skins[player.mo.skin].normalspeed * 5) / 2 then
							player.normalspeed = (skins[player.mo.skin].normalspeed * 5) / 2
						end
					elseif player.hyper.capable == true then
						if player.normalspeed < (skins[player.mo.skin].normalspeed * 3) then
							player.normalspeed = (skins[player.mo.skin].normalspeed * 3)
						end
					end
				end
				player.cpanel = $ - 1
			end
		end
	end
end)